Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 591196 - xfsprogs-3.0.3 ima_file_free
Summary: xfsprogs-3.0.3 ima_file_free
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 12
Hardware: x86_64
OS: Linux
low
high
Target Milestone: ---
Assignee: Eric Sandeen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-05-11 16:11 UTC by arth
Modified: 2010-12-03 14:48 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-12-03 14:48:48 UTC


Attachments (Terms of Use)

Description arth 2010-05-11 16:11:19 UTC
Description of problem:

In the latest released version of xfsprogs, xfs_fsr causes kernel call traces to the syslog, and eventually freezes the file system.
Normally ima_file_free traces seem to be harmless, but not in this case.


Version-Release number of selected component (if applicable):

xfsprogs-3.0.3-3.fc12.x86_64  (likely also a problem in F13)


How reproducible:


Steps to Reproduce:
1. install xfsprogs
2. run xfs_fsr, e.g. xfs_fsr -v /path/to/xfsfilesystem
3. check the syslog
  
Actual results:

From syslog:

May 11 11:39:31 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:0 o:0 f:0)
May 11 11:39:31 gvrsimah01 kernel: Pid: 16523, comm: xfs_fsr Not tainted 2.6.32.11-99.fc12.x86_64 #1
May 11 11:39:31 gvrsimah01 kernel: Call Trace:
May 11 11:39:31 gvrsimah01 kernel: [<ffffffff812011bc>] ima_file_free+0xa7/0x10c
May 11 11:39:31 gvrsimah01 kernel: [<ffffffff8111c861>] __fput+0x13a/0x1dc
May 11 11:39:31 gvrsimah01 kernel: [<ffffffff8111c91d>] fput+0x1a/0x1c
May 11 11:39:31 gvrsimah01 kernel: [<ffffffff81118db1>] filp_close+0x68/0x72
May 11 11:39:31 gvrsimah01 kernel: [<ffffffff81118e58>] sys_close+0x9d/0xd2
May 11 11:39:31 gvrsimah01 kernel: [<ffffffff81011d32>] system_call_fastpath+0x16/0x1b

After this occurs, "ima_file_free:   open/free imbalance" tends to repeat quite often -- both for named files, and unnamed files.

Example:

May 11 11:39:47 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:48 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)
May 11 11:39:51 gvrsimah01 kernel: ima_file_free:  open/free imbalance (r:0 w:-1 o:-1 f:0)


Additional info:

n a relatively active file system, the file system will eventually freeze up (with no further errors logged).  When I say "freeze", I mean that all IO operations that can't be served from cache will never return.
A server with a cron job that runs xfs_fsr daily froze up three times before the root cause was determined.  The more often xfs_fsr runs, the greater the risk seems of this happening.

Comment 1 Eric Sandeen 2010-05-11 16:21:59 UTC
Almost certainly a kernel problem not xfsprogs... what kernel version are you running?

-Eric

Comment 2 Eric Sandeen 2010-05-11 16:22:43 UTC
Oh sorry, "2.6.32.11-99.fc12.x86_64 #1"  :)

-Eric

Comment 3 Eric Paris 2010-05-11 18:59:21 UTC
Is there any chance this could be tested on a 2.6.33 kernel?  There is a whole series of IMA object lifetime changes which went into .33 intended to fix a whole host of issues like these.  I don't know for sure if it will fix it, but I do know many things wrong with IMA in .32

Comment 4 Bug Zapper 2010-11-03 15:05:30 UTC
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 5 Bug Zapper 2010-12-03 14:48:48 UTC
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.